%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef YYSTYPE
#define YYSTYPE char *
#endif

char* result = "";

int yylex(void);
int yyerror(char* s);

%}

%token REGISTER REGISTER_REF OP OP_CTRL VALUE
%token PAR_O PAR_C
%left COMMA
%right SEPARATION

%%
program:
    input SEPARATION instruction {
        }
    |   instruction {
        }
;

input:
    PAR_O content PAR_C {
        $$ = $2;
        }
;

content:
    VALUE COMMA content {
        asprintf(&$$, "%s, %s ", $1, $3);
        }
    |   VALUE {
        $$ = $1;
        }
;

instruction:
    line SEPARATION instruction {
        asprintf(&$$, "%s%s", $1, $3);
        }
    |   line SEPARATION {
        $$ = $1;
        }
    |   line {
        $$ = $1;
        }
;

line:
    OP_CTRL PAR_O args_ctrl PAR_C {
        asprintf(&$$, "{\"op\": Ram.op, \"args\": (%s, %s)}, ", $1, $2);
        }
    |   OP PAR_O args PAR_C {
        asprintf(&$$, "{\"op\": Ram.op_ctrl, \"args\": (%s, %s)}, ", $1, $2);
        }
;
args:
    arg COMMA arg COMMA arg {
        asprintf(&$$, "%s, %s, %s", $1, $3, $5);
        }
    |   arg {
        $$ = $1;
        }
;

args_ctrl:
    VALUE COMMA arg COMMA arg {
        asprintf(&$$, "%c, %s, %s", $1, $3, $5);
        }
    |   VALUE {
        $$ = $1;
        }

arg:
    REGISTER_REF {
        char *index_str = strdup($1 + 3); // copy from 4th char
        asprintf(&$$, "('%c', '%c', '%c', %s), ", $1[1], index_str, $1[2], $1[0]);
        // r@i1 -> r register, index in i1
        // Python args: type_register, index, ref_origin, ref_target
        // r@i1 -> ('@', '1', 'i', 'r')
        free(index_str);
        }
    |   REGISTER {
        char *index_str = strdup($1 + 1); // copy from 2nd char
        asprintf(&$$, "('%c', %s), ", $1[0], index_str);
        free(index_str);
        }
    |   VALUE {
        asprintf(&$$, "('value', %s), ", $1);
        }
;

%%

int main() {
    yyparse();

    return 0;
}
